<?php
/*
 * forms.inc.php
 * -------------
 *
 * Based heavily on Owen's code.
 *
 * (C)2004 Stewart Smith
 * (C)2004 Owen Rodda
 */


function radiolist($name, $setup) {
  echo $setup['html'];
  $n = 1;
  echo "<div class=\"radiolist\">\n";
  foreach($setup['options'] as $what) {
    echo "<p><label for=\"$name$n\">$what</label>";
    echo '<input type="radio" id="'.$name.$n.'" name="'.$name;
    echo '" value="'.$what.'" ';
    if($setup['value'] == $what) {
      echo ' checked="checked"';
    }
    echo "/></p>\n";
    $n++;
  }
  echo "</div>\n";
}

function field_phone($name,$setup) {
  echo "(<input type=\"text\" name=\"$name-area\" id=\"$name\" size=\"4\" maxlength=\"5\" value=\"{$setup['area']}\" />) ";
  echo "<input type=\"text\" id=\"$name-phone\" name=\"$name\" ";
  if(isset($setup['maxlength'])) {
    echo "maxlength=\"{$setup['maxlength']}\" ";
  }
  echo "value=\"{$setup['phone']}\" />";
}

function field_text($name,$setup) {
  echo "<input type=\"text\" id=\"$name\" name=\"$name\" ";
  if(isset($setup['maxlength'])) {
    echo "maxlength=\"{$setup['maxlength']}\" ";
  }
  echo "value=\"{$setup['value']}\" />";
}

function field_select($name,$setup) {
  echo "<select name=\"$name\" id=\"$name\">\n";
  foreach($setup['options'] as $option) {
    echo "<option";
    
    if($setup['value'] == $option) {
      echo " selected=\"selected\"";
    }
    echo ">$option</option>\n";
  }
  echo "</select>";
}

function output_field($name, $setup) {
  switch($setup['type']) {
  case 'custom':
    eval($setup['output'] . '($name, $setup);');
    return;
  case 'html':
    echo $setup['html'];
    return;
  case 'calculated':
    return;
  }

  if(isset($setup['error']))
    echo "<div class=\"error\">";

  echo "<p class=\"field\">";
  echo "<label for=\"$name\">{$setup['label']}";
  if(isset($setup['required']))
    echo " <span class=\"mandatory\">*</span>";
  echo "</label>";

  switch($setup['type']) {
  case 'phone':
    field_phone($name,$setup);
    break;
  case 'text':
  case 'date':
    field_text($name,$setup);
    break;
  case 'select':
    field_select($name,$setup);
    break;
  default:
    echo "<strong>Unrecognised field type</strong>";
  }
  if(isset($setup['note']) && !isset($setup['error']))
    echo "<br />{$setup['note']}";
  echo "</p>\n";
  if(isset($setup['error']))
    echo "<p><img src=\"images/error\" width=\"16\" height=\"16\" alt=\"Error:\" /> {$setup['error']}</p></div>\n";
}

function output_form(&$fields, $submit="Submit", $method="post", $query='') {
  echo "<form action=\"{$_SERVER['PHP_SELF']}?page={$_GET['page']}$query\" method=\"$method\">\n";
  foreach($fields as $fieldname => $field)
    output_field($fieldname, $field);
  echo "<p class=\"submit\"><input type=\"submit\" value=\"$submit\" /></p>\n";
  echo "</form>\n";
}

function format_errorlist($el) {
  return "<div class=\"error\">\n<p><img src=\"images/error\" width=\"16\" height=\"16\" alt=\"Error:\" /> Your answers contained some errors. Please check the following and try again:</p>\n<ul><li>" . join("</li>\n<li>", $el) . "</li>\n</ul>\n<p>Explanations for these errors are provided below the relevant fields.</p></div>\n";
}
function validate(&$fields, &$source) {
  $errorlist = array();
  foreach($fields as $field => $values) {
    if(!isset($source[$field])) {
      if(!isset($values['default'])) {
	$values['default'] = '';
      }
      $fields[$field]['value'] = htmlentities($values['default']);
      if($values['type'] == 'phone') {
	preg_match('/^(\d*)-?(\d*)$/', $values['default'], $m);
	$fields[$field]['area'] = $m[1];
	$fields[$field]['phone'] = $m[2];
      }
    } else {
      $val = $source[$field];
      if($values['type'] == 'phone') {
	$fields[$field]['area'] = preg_replace('/\D/', '', $source["$field-area"]);
	$fields[$field]['phone'] = preg_replace('/\D/', '', $source["$field"]);
	$val =  $fields[$field]['area']. '-' . $fields[$field]['phone'];
      }
      $fields[$field]['value'] = htmlentities(get_magic_quotes_gpc()?
					      stripslashes($source[$field])
					      :$source[$field]);
      if(isset($values['valid'])) {
	if($values['type'] == 'date') {
	  // americanise
	  $aval = preg_replace('|\s*\b(\d\d?)\s*[./\-\s]\s*(\d\d?)\b\s*|', '$2/$1', $val);
	  $aval = preg_replace('|(\d{1,2})[.\-\/](\d{1,2})[.\-\/](\d{2,4})|', '$1/$2/$3', $aval);
	  $aval = preg_replace('|(\d{4})[.\-\/](\d{1,2})[.\-\/](\d{1,2})|', '$1-$3-$2', $aval);
	  $date = @strtotime($aval);
	  
	} else {
	  unset($date);
	}
	foreach($values['valid'] as $test => $error) {
	  $result = false;
	  eval('$result = (' . $test . ');');
	  if(!$result) {
	    $errorlist[] = $values['label'];
	    $fields[$field]['error'] = $error;
	    break;
	  }
	}
      }
      if($values['type'] == 'date' and !isset($fields[$field]['error']) and isset($values['format'])) {
	$fields[$field]['value'] = date($values['format'], $date);
      }
    }
  }
  if(count($errorlist)) {
    return format_errorlist($errorlist);
  } else return false;
}


?>