<?php
/*
 * Signup
 * ------
 *
 * Second stage of signing up for membership.
 * This section will only be run if the input has been
 * validated first (i.e. the first form submits signup_validate,
 * and the second one calls us (signup)).
 *
 * We then send out a mail asking them to confirm their membership,
 * and we insert a member_status of 'Applied' into the database.
 *
 * (C)2003 Stewart Smith
 * Distributed under the GPL.
 */

if($_POST['first_name']==''
   || $_POST['last_name']==''
   || $_POST['address1']==''
   || $_POST['suburb']==''
   || $_POST['postcode']==''
   || $_POST['country']==''
   || $_POST['email']=='')
{
  $_POST['function']='signup_validate';
}
else
{
  /*
   * FIXME: This should be one transaction. Crashing halfway isn't that
   * bad, we're just left with records in members which aren't a member
   * of anything.
   */
  $id = $dbh->nextId('public.members_id_seq');
  
  if($_POST['Sex']=='Male')
    $sexval = 'M';
  else if ($_POST['Sex']=='Female')
    $sexval = 'F';
  else
    $sexval = ' ';
  
  sql_insert('members',array(
			     'id'          => $id,
			     'first_name'  => $_POST['first_name'],
			     'middle_name' => $_POST['middle_name'],
			     'last_name'   => $_POST['last_name'],
			     'dob'         => $_POST['dob'],
			     'sex'         => $sexval,
			     'address1'    => $_POST['address1'],
			     'address2'    => $_POST['address2'],
			     'suburb'      => $_POST['suburb'],
			     'postcode'    => $_POST['postcode'],
			     'state'       => $_POST['state'],
			     'country'     => $_POST['country'],
			     'email'       => $_POST['email'],
			     'phone_home'  => $_POST['phone_home'],
			     'phone_mobile'=> $_POST['phone_mobile']));
  /* We don't need to quote anything
     in this query as it's all valid anyway (from the DB or subselect).
       
     This basically stores that the member (created above) is applying for
     membership to our organisation (as set in the config). The 'Pending'
     type of membership lasts for a year. Although it could be different...
  */
  $sql = 'insert into org_members (org_id,member_id,member_type_id,start_date,expiry) values ('.$config['org_id'].','.$id.",(select id from member_types where type='Applied'),now(),now()+'1year')";
  my_syslog(LOG_DEBUG,$sql);
  $result = $dbh->query($sql);
  if (DB::isError($result)) {
    my_syslog(LOG_INFO,$result->getMessage());
  }
  include $config['basedir'].'/site-messages/signup/application-request-for-confirm.inc';
}
?>